macroScript SkyDome category:"Bobo_s Tools"
(


--SkyDome
--Version 0.36
--Started: 03/05/2000
--Edited:  09/20/2000
--by Borislav Petrov
--http://gfxcentral.com/bobo/
--------------------------------------------------

global skydome_float
global sun_object

rollout skydome_roll "SkyDome"
(
group "SkyDome Geometry"
(
spinner dome_radius "Radius:" range:[100,100000.0,1000.0] fieldwidth:45
spinner segs_value "Segments:" range:[1,10,4] type:#integer fieldwidth:45
spinner horizon_height "Horizon Height:" range:[0,1000,100] fieldwidth:45 
radiobuttons material_from labels:#("Default","Medit Slot 1") 

)

button create_dome "CREATE NEW SKYDOME" width:160 height:30 tooltip:"Press to Create a new SkyDome or Update the geometry of an existing one."
progressbar create_progress height:8 width:160 align:#center color:(color 0 0 100)
button update_dome "Update SkyLights" width:160 tooltip:"Press to apply all Light and Shadow values to the SkyLights"


fn filter_sunlight obj = (classof obj.controller == Sunlight_Slave_Controller)

group "SkyDome Lighting"
(
button delete_sun "X" width:20 across:2 align:#left tooltip:"Remove Sun Light"
pickbutton pick_sun ">Pick Sun Light" width:125 filter:filter_sunlight align:#right tooltip:"Pick a MAX Sun System Light to define time-based Major Light Direction"
edittext number_lights "# Lights" text:"" fieldwidth:54 align:#right
spinner light_intensity "Base Sky Intensity:" range:[0,20,1.5] fieldwidth:45
spinner sky_contrast "Contrast Thresh.:" range:[0,1,0.5] fieldwidth:45 enabled:false
checkbutton show_falloff "Show" align:#left across:2 height:20 width:58 highlightcolor:(color 255 255 200) offset:[-2,-3]
spinner shadow_falloff "Falloff:" range:[10,10000,100] fieldwidth:45 type:#integer
spinner color_sat "Saturation Limit:" range:[0,255,32] type:#integer fieldwidth:45
button sat_16 "16" width:35 across:4 align:#left
button sat_32 "32" width:35 align:#center
button sat_64 "64" width:35 align:#center
button sat_128 "128" width:35 align:#right
checkbox spec_yes "Affect Specular Highlights" checked:true
)

group "SkyLight Shadows"
(
checkbutton cast_shadows "Shadows" checked:true algin:#left across:2 offset:[-8,-2] height:20 width:60 highlightcolor:(color 200 255 200)\
tooltip:"Toggle SkyLight Shadow Casting On/Off"
colorpicker shadow_color "Color" color:(color 0 0 0)  height:17 fieldwidth:50 align:#right

spinner shadow_multi "Shadow Density:" range:[-10000,10000,1] fieldwidth:45 type:#float
spinner shadow_samples "Sample Range:" range:[0,50,10] fieldwidth:45 type:#float

checkbutton abs_bias "Absolute" checked:false algin:#left across:2 highlightcolor:(color 200 200 255) offset:[-9,-3] height:20 width:60\
tooltip:"Toggle Absolute/Relative Shadow Map Bias"
spinner shadow_bias "Bias:" range:[0,1000,1] fieldwidth:45 type:#float align:#right

radiobuttons light_type labels:#("Direct","Spot") 
spinner map_size "Shadow Map Size:" range:[16,1024,64] fieldwidth:45 type:#integer
button max_64 "64" width:35 across:4 align:#left
button max_128 "128" width:35 align:#center
button max_256 "256" width:35 align:#center
button max_512 "512" width:35 align:#right
)

on max_64 pressed do map_size.value = 64
on max_128 pressed do map_size.value = 128
on max_256 pressed do map_size.value = 256
on max_512 pressed do map_size.value = 512

on sat_16 pressed do color_sat.value = 16
on sat_32 pressed do color_sat.value = 32
on sat_64 pressed do color_sat.value = 64
on sat_128 pressed do color_sat.value = 128


fn update_appdata sky_obj =
(
try
(
app_data_start = 20000818
setAppData sky_obj (app_data_start+1) (skydome_roll.map_size.value as string)
setAppData sky_obj (app_data_start+2) (skydome_roll.shadow_falloff.value as string)
setAppData sky_obj (app_data_start+3) (skydome_roll.shadow_samples.value as string)
setAppData sky_obj (app_data_start+4) (skydome_roll.shadow_color.color as string)
setAppData sky_obj (app_data_start+5) (skydome_roll.shadow_multi.value as string)
setAppData sky_obj (app_data_start+6) (skydome_roll.color_sat.value  as string)
setAppData sky_obj (app_data_start+7) (skydome_roll.light_intensity.value  as string)
setAppData sky_obj (app_data_start+8)  (skydome_roll.light_type.state  as string)
setAppData sky_obj (app_data_start+9)  (skydome_roll.spec_yes.checked  as string)
setAppData sky_obj (app_data_start+10) (skydome_roll.dome_radius.value  as string)
setAppData sky_obj (app_data_start+11) (skydome_roll.segs_value.value  as string)
setAppData sky_obj (app_data_start+12) (skydome_roll.horizon_height.value  as string)
setAppData sky_obj (app_data_start+13) (skydome_roll.material_from.state  as string)
setAppData sky_obj (app_data_start+14) (skydome_roll.show_falloff.state  as string)
setAppData sky_obj (app_data_start+16) (skydome_roll.sky_contrast.value as string)
setAppData sky_obj (app_data_start+17) (skydome_roll.cast_shadows.state as string)
setAppData sky_obj (app_data_start+18) (skydome_roll.abs_bias.state as string)
setAppData sky_obj (app_data_start+19) (skydome_roll.shadow_bias.value as string)

if sun_object != undefined then 
	(
	setAppData sky_obj (app_data_start+15) (sun_object.name)
	)
	else
	(
	setAppData sky_obj (app_data_start+15) ("")
	)
)
catch()
)


on delete_sun pressed do
(
sun_object = undefined
pick_sun.text = ">Pick Sun Light"
update_appdata $SkyDome
sky_contrast.enabled = false
)

on pick_sun picked obj do
(
sun_object = obj
sun_object.on = false
pick_sun.text = obj.name
sky_contrast.enabled = true
update_appdata $SkyDome
)


on show_falloff changed state do
(
try
(
$SkyLight01.Isfrozen = not state
$SkyLight01.IsHidden = not state
$SkyLight01.ShowCone = state
update_appdata $SkyDome
)
catch
()
)


on create_dome pressed do
(
disableSceneRedraw()

--GET OLD POSITION OF SKYDOME--
try(old_sd_pos = $SkyDome.pos)catch(old_sd_pos = [0,0,0])

--DELETE OLD OBJECTS--
delete $SkyDome*
delete $SkyLight*

--GENERATE DOME OBJECT--
sky_obj = geosphere radius:dome_radius.value segs:segs_value.value name:"SkyDome" pos:[0,0,0]
select sky_obj
max modify mode
sl = sliceModifier ()
sl.Slice_Type=3
sl.SlicePlane.position=[0,0,1]
modpanel.addmodtoselection sl

n_m = normalModifier flip:true
modpanel.addmodtoselection n_m

uv = UVWmap maptype:2
modpanel.addmodtoselection uv
uv.Gizmo.position = [0,0,0]


sky_obj.castshadows = false
sky_obj.receiveshadows = false

sky_map = Bitmaptexture filename:"CldsMap.jpg"

if material_from.state == 1 then
(
sky_material = standardmaterial selfillumamount:100 diffusemap:sky_map diffuse:(color 255 255 255) name:"SkyDome"
)
else
(
sky_material = meditmaterials[1] 
if classof sky_material.diffusemap != BitmapTexture then 
	(
	sky_material.diffusemap = sky_map
	)
	else
	(
	sky_map = sky_material.diffusemap
	)
)

sky_obj.material = sky_material 
showtexturemap sky_material sky_map on
target_pos = sky_obj.pos

work_bitmap = sky_obj.material.diffusemap.bitmap
bmp_w = work_bitmap.width - 1
bmp_h = work_bitmap.height - 1

num_v = sky_obj.mesh.numverts 

if sun_object != undefined then
(
d1 = dummy()
d2 = dummy()
in coordsys sun_object d1.pos = [0,0,-10]
in coordsys sun_object d2.pos = [0,0,-100]
sun_ray = ray d1.pos (d2.pos-d1.pos)
delete d1
delete d2
)

lights_count =0
for v = 1 to num_v do
(
create_progress.value = 100.0*v/num_v

t_pos =getvert sky_obj.mesh v
if in coordsys sky_obj t_pos.z >= horizon_height.value then lights_count +=1
)

multi_part = 5.0*light_intensity.value/(lights_count as float)

for v = 1 to num_v do
(
t_pos =getvert sky_obj.mesh v

if t_pos.z > horizon_height.value then
(
tv_pos = gettvert sky_obj.mesh v
pixel_pos_x = tv_pos.x*bmp_w
pixel_pos_y = bmp_h - (tv_pos.y*bmp_h)
pixel_color = getpixels work_bitmap [pixel_pos_x,pixel_pos_y] 1

point_color = pixel_color[1] --color pixel_color[1].value pixel_color[1].value pixel_color[1].value
if point_color.s > color_sat.value then point_color.s = color_sat.value

point_value = multi_part * ((pixel_color[1].value/255.0))

t_o = targetObject pos:target_pos
case light_type.state of
(
1: sky_light = targetDirectionalLight target:t_o color:point_color pos:t_pos castshadows:cast_shadows.state overShoot:true raytracedshadows:false
2: sky_light = targetSpot target:t_o color:point_color pos:t_pos castshadows:cast_shadows.state overShoot:true raytracedshadows:false
)

sky_light.sampleRange=shadow_samples.value
sky_light.mapsize=map_size.value
sky_light.mapbias=shadow_bias.value
sky_light.absoluteMapBias=abs_bias.checked
sky_light.falloff = shadow_falloff.value 
sky_light.hotspot = shadow_falloff.value - 10
sky_light.shadowColor = shadow_color.color
sky_light.shadowMultiplier = shadow_multi.value
sky_light.affectSpecular=spec_yes.checked
sky_light.name = uniquename "SkyLight"
sky_light.parent = sky_obj
t_o.parent = sky_obj
freeze sky_light
hide sky_light

if sun_object != undefined then
(
dir_ray = sky_light as ray
sun_angle = (dot sun_ray.dir dir_ray.dir)
if sun_angle < sky_contrast.value then sun_angle = sky_contrast.value
point_value *= ((sun_angle)*1.5)
)

sky_light.multiplier = point_value 

)--end if
)--end v loop
number_lights.text = ($SkyLight*).count as string
update_appdata sky_obj
$SkyLight01.Isfrozen = not show_falloff.state
$SkyLight01.IsHidden = not show_falloff.state
$SkyLight01.ShowCone = show_falloff.state
sky_obj.pos = old_sd_pos
enableSceneRedraw()
create_progress.value = 0
)--end on

on update_dome pressed do
(
lights_array = $SkyLight*

if sun_object != undefined then
(
d1 = dummy()
d2 = dummy()
in coordsys sun_object d1.pos = [0,0,-10]
in coordsys sun_object d2.pos = [0,0,-100]
sun_ray = ray d1.pos (d2.pos-d1.pos)
delete d1
delete d2
)

if lights_array.count > 0 then
(
counter = 0
for l in lights_array do
(
counter += 1
create_progress.value = 100.0*counter/lights_array.count
l.mapsize=map_size.value
l.mapbias=shadow_bias.value
l.absoluteMapBias=abs_bias.checked
l.falloff = shadow_falloff.value 
l.hotspot = shadow_falloff.value - 10
l.sampleRange = shadow_samples.value
l.shadowColor = shadow_color.color
l.shadowMultiplier = shadow_multi.value
l.affectSpecular=spec_yes.checked
l.castshadows = cast_shadows.state
l_col = l.color
if l_col.s > color_sat.value then l_col.s =  color_sat.value
l.color = l_col 
case light_type.state of
	(
	1: l.type = #targetDirect
	2: l.type = #targetSpot
	) 
multi_part = 5.0*light_intensity.value/(lights_array.count as float)
	
if sun_object != undefined then
(
dir_ray = l as ray
sun_angle = (dot sun_ray.dir dir_ray.dir)
if sun_angle < sky_contrast.value then sun_angle = sky_contrast.value
multi_part *= ((sun_angle)*1.5)
)
l.multiplier = multi_part * ((l.color.value/255.0))
)--end l
create_progress.value = 0
update_appdata $SkyDome 
)--end if
)--end on
)--end roll

try(closerolloutfloater skydome_float)catch()
skydome_float = newrolloutfloater "SkyDome v0.36" 200 620 100 100
addrollout skydome_roll skydome_float
skydome_roll.number_lights.text = (($SkyLight*).count as string)
try
(
sky_obj = $SkyDome
app_data_start = 20000818
skydome_roll.map_size.value =execute (getAppData sky_obj (app_data_start+1) ) 
skydome_roll.shadow_falloff.value =execute (getAppData sky_obj (app_data_start+2) ) 
skydome_roll.shadow_samples.value =execute (getAppData sky_obj (app_data_start+3) ) 
skydome_roll.shadow_color.color =execute (getAppData sky_obj (app_data_start+4) ) 
skydome_roll.shadow_multi.value =execute (getAppData sky_obj (app_data_start+5) ) 
skydome_roll.color_sat.value =execute (getAppData sky_obj (app_data_start+6) ) 
skydome_roll.light_intensity.value =execute (getAppData sky_obj (app_data_start+7) ) 
skydome_roll.light_type.state =execute (getAppData sky_obj (app_data_start+8) ) 
skydome_roll.spec_yes.checked =execute (getAppData sky_obj (app_data_start+9) ) 
skydome_roll.dome_radius.value =execute (getAppData sky_obj (app_data_start+10) ) 
skydome_roll.segs_value.value =execute (getAppData sky_obj (app_data_start+11) )
skydome_roll.horizon_height.value =execute (getAppData sky_obj (app_data_start+12) )
skydome_roll.material_from.state =execute (getAppData sky_obj (app_data_start+13) ) 
skydome_roll.show_falloff.state =execute (getAppData sky_obj (app_data_start+14) ) 
skydome_roll.sky_contrast.value =execute (getAppData sky_obj (app_data_start+16) ) 
skydome_roll.cast_shadows.state =execute (getAppData sky_obj (app_data_start+17) ) 

sun_name = (getAppData sky_obj (app_data_start+15) ) 
sun_object = execute ("$'"+sun_name+"'")
skydome_roll.pick_sun.text = sun_name
skydome_roll.sky_contrast.enabled = true

skydome_roll.abs_bias.state =execute (getAppData sky_obj (app_data_start+18) ) 
skydome_roll.shadow_bias.value =execute (getAppData sky_obj (app_data_start+19) ) 
)
catch
(
)
)--end script